unit EditTstU;

interface

uses
  WinProcs, WinTypes, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Menus, EditUndo;

type
  TForm1 = class(TForm)
    edtTarget: TEditUndo;
    edtSource: TEdit;
    btnInitText: TSpeedButton;
    btnReplaceSel: TSpeedButton;
    btnReplaceAll: TSpeedButton;
    MainMenu1: TMainMenu;
    mnuEdit: TMenuItem;
    mnuUndo: TMenuItem;
    Timer1: TTimer;
    chkCanUndo: TCheckBox;
    procedure btnInitTextClick(Sender: TObject);
    procedure btnReplaceSelClick(Sender: TObject);
    procedure btnReplaceAllClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure mnuUndoClick(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.btnInitTextClick(Sender: TObject);
begin
  edtTarget.Text := 'The quick brown fox jumps over the lazy dog';
  edtTarget.SelStart := 4;
  edtTarget.SelLength := 5
end;

procedure TForm1.btnReplaceSelClick(Sender: TObject);
begin
  edtTarget.SelText := edtSource.Text
end;

procedure TForm1.btnReplaceAllClick(Sender: TObject);
begin
  edtTarget.Text := edtSource.Text
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  chkCanUndo.Checked := LongBool(edtTarget.Perform(em_CanUndo, 0, 0))
end;

procedure TForm1.mnuUndoClick(Sender: TObject);
begin
  ActiveControl.Perform(em_Undo, 0, 0)
end;

initialization
  RegisterClass(TLabel)
end.
